#include <stdio.h>
#include <stdlib.h>



int main(int argc, char *argv[])
{
    FILE *file;
    int i,j,pp,cnt;
    unsigned char scr[6912];

    if(argc<2)
    {
        printf("ZX Spectrum Screen PAPER remover by Shiru (shiru@mail.ru) 11.08.10\n");
        printf("Usage: scrunpaper screen.scr\n");
        return 0;
    }

    file=fopen(argv[1],"rb");
    if(!file) return 1;
    
    fread(scr,6912,1,file);
    fclose(file);

    cnt=0;

    for(i=0;i<768;i++)
    {
        if((scr[i+6144]>>3)&7)
        {
            scr[i+6144]=(scr[i+6144]&0xc0)|((scr[i+6144]>>3)&7);
            pp=(i/32/8)*2048+((i/32)&7)*32+(i&31);
            for(j=0;j<2048;j+=256) scr[pp+j]^=255;
            cnt++;
        }
    }
    
    if(!cnt) return 1;

    file=fopen(argv[1],"wb");
    fwrite(scr,6912,1,file);
    fclose(file);

    return 0;
}
